#

API Docs for: v2.11.1
Show: Inherited Protected Private Deprecated

# Ember.Checkbox Class

Extends Ember.Component
Defined in: `packages/ember-glimmer/lib/components/checkbox.js:10`
Module: ember-views
Parent Module: ember

The internal class used to create text inputs when the `{{input}}` helper is used with `type` of `checkbox`.

See Ember.Templates.helpers.input for usage details.

## Direct manipulation of `checked`

The `checked` attribute of an `Ember.Checkbox` object should always be set through the Ember object or by interacting with its rendered element representation via the mouse, keyboard, or touch. Updating the value of the checkbox via jQuery will result in the checked value of the object and its element losing synchronization.

## Layout and LayoutName properties

Because HTML `input` elements are self closing `layout` and `layoutName` properties will not be applied. See Ember.View's layout section for more information.

- Index
- Methods
- Properties
- Events

## Item Index

### Methods

- $
- _lazyInjections
- _onLookup
- _scheduledDestroy
- addObserver
- append
- appendTo
- beginPropertyChanges
- cacheFor
- decrementProperty
- destroy
- didReceiveAttrs
- didRender
- didUpdate
- didUpdateAttrs
- endPropertyChanges
- findElementInParentElement
- get
- getChildViews
- getProperties
- getRootViews
- getViewBoundingClientRect
- getViewBounds
- getViewClientRects
- getViewElement
- getViewId
- getViewRange
- getWithDefault
- handleEvent
- has
- hasObserverFor
- incrementProperty
- init
- matches
- nearestOfType deprecated
- nearestWithProperty deprecated
- notifyPropertyChange
- off
- on
- one
- propertyDidChange
- propertyWillChange
- readDOMAttr
- removeObserver
- renderToElement deprecated
- reopen
- reopenClass
- replaceIn
- rerender
- send
- sendAction
- set
- setProperties
- toggleProperty
- toString
- trigger
- triggerAction
- willDestroy
- willRender
- willUpdate

### Properties

- actions
- ariaRole
- childViews
- classNameBindings
- classNames
- concatenatedProperties
- element
- elementId
- isDestroyed
- isDestroying
- isVisible
- layout
- layoutName
- mergedProperties
- parentView
- tagName

### Events

- didInsertElement
- didReceiveAttrs
- didRender
- didUpdate
- didUpdateAttrs
- parentViewDidChange
- willClearRender
- willDestroyElement
- willInsertElement
- willRender
- willUpdate

## Methods

### `$`

(

- `[selector]`

)
JQuery public

Inherited from Ember.ViewMixin but overwritten in `packages/ember-glimmer/lib/component.js:833`

Returns a jQuery object for this component's element. If you pass in a selector string, this method will return a jQuery object, using the current element as its buffer. For example, calling `component.$('li')` will return a jQuery object containing all of the `li` elements inside the DOM element of this component.

#### Parameters:

- `[selector]` String optional
  a jQuery-compatible selector string

#### Returns:

JQuery: the jQuery object for the DOM node

### `_lazyInjections`

() Object private

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:930`

Returns a hash of property names and container names that injected properties will lookup on the container lazily.

#### Returns:

Object: Hash of all lazy injected property keys to container names

### `_onLookup`

() private

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:921`

Provides lookup-time type validation for injected properties.

### `_scheduledDestroy`

() private

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:487`

Invoked by the run loop to actually destroy the object. This is scheduled for execution by the `destroy` method.

### `addObserver`

(

- `key`
- `target`
- `method`

)
public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:333`

Adds an observer on a property. This is the core method used to register an observer for a property. Once you call this method, any time the key's value is set, your observer will be notified. Note that the observers are triggered any time the value is set, regardless of whether it has actually changed. Your observer should be prepared to handle that. You can also pass an optional context parameter to this method. The context will be passed to your observer method whenever it is triggered. Note that if you add the same target/method pair on a key multiple times with different context parameters, your observer will only be called once with the last context you passed. ### Observer Methods Observer methods you pass should generally have the following signature if you do not pass a `context` parameter: ```javascript fooDidChange: function(sender, key, value, rev) { }; ``` The sender is the object that changed. The key is the property that changes. The value property is currently reserved and unused. The rev is the last property revision of the object when it changed, which you can use to detect if the key value has really changed or not. If you pass a `context` parameter, the context will be passed before the revision like so: ```javascript fooDidChange: function(sender, key, value, context, rev) { }; ``` Usually you will not need the value, context or revision parameters at the end. In this case, it is common to write observer methods that take only a sender and key value as parameters or, if you aren't interested in any of these values, to write an observer that has no parameters at all.

#### Parameters:

- `key` String
  The key to observer
- `target` Object
  The target object to invoke
- `method` String | Function
  The method to invoke.

### `append`

() Ember.View private

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:267`

Appends the view's element to the document body. If the view does not have an HTML representation yet the element will be generated automatically. If your application uses the `rootElement` property, you must append the view within that element. Rendering views outside of the `rootElement` is not supported. Note that this method just schedules the view to be appended; the DOM element will not be appended to the document body until all bindings have finished synchronizing.

#### Returns:

Ember.View: receiver

### `appendTo`

(

- `A`

)
Ember.View private

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:130`

Appends the view's element to the specified parent element. Note that this method just schedules the view to be appended; the DOM element will not be appended to the given element until all bindings have finished synchronizing. This is not typically a function that you will need to call directly when building your application. If you do need to use `appendTo`, be sure that the target element you are providing is associated with an `Ember.Application` and does not have an ancestor element that is associated with an Ember view.

#### Parameters:

- `A` String | DOMElement | JQuery
  selector, element, HTML string, or jQuery object

#### Returns:

Ember.View: receiver

### `beginPropertyChanges`

() Ember.Observable private

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:231`

Begins a grouping of property changes. You can use this method to group property changes so that notifications will not be sent until the changes are finished. If you plan to make a large number of changes to an object at one time, you should call this method at the beginning of the changes to begin deferring change notifications. When you are done making changes, call `endPropertyChanges()` to deliver the deferred change notifications and end deferring.

#### Returns:

Ember.Observable:

### `cacheFor`

(

- `keyName`

)
Object public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:490`

Returns the cached value of a computed property, if it exists. This allows you to inspect the value of a computed property without accidentally invoking it if it is intended to be generated lazily.

#### Parameters:

- `keyName` String

#### Returns:

Object: The cached value of the computed property, if any

### `decrementProperty`

(

- `keyName`
- `decrement`

)
Number public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:453`

Set the value of a property to the current value minus some amount. ```javascript player.decrementProperty('lives'); orc.decrementProperty('health', 5); ```

#### Parameters:

- `keyName` String
  The name of the property to decrement
- `decrement` Number
  The amount to decrement by. Defaults to 1

#### Returns:

Number: The new property value

### `destroy`

() private

Inherited from Ember.CoreObject but overwritten in `packages/ember-views/lib/mixins/view_support.js:367`

You must call `destroy` on a view to destroy the view (and all of its child views). This will remove the view from any parent node, then make sure that the DOM element managed by the view can be released by the memory manager.

### `didReceiveAttrs`

() public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:709`

Available since 1.13.0

Called when the attributes passed into the component have been updated. Called both during the initial render of a container and during a rerender. Can be used in place of an observer; code placed here will be executed every time any attribute updates.

### `didRender`

() public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:729`

Available since 1.13.0

Called after a component has been rendered, both on initial render and in subsequent rerenders.

### `didUpdate`

() public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:793`

Available since 1.13.0

Called when the component has updated and rerendered itself. Called only during a rerender, not during an initial render.

### `didUpdateAttrs`

() public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:761`

Available since 1.13.0

Called when the attributes passed into the component have been changed. Called only during a rerender, not during an initial render.

### `endPropertyChanges`

() Ember.Observable private

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:251`

Ends a grouping of property changes. You can use this method to group property changes so that notifications will not be sent until the changes are finished. If you plan to make a large number of changes to an object at one time, you should call `beginPropertyChanges()` at the beginning of the changes to defer change notifications. When you are done making changes, call this method to deliver the deferred change notifications and end deferring.

#### Returns:

Ember.Observable:

### `findElementInParentElement`

(

- `parentElement`

)
DOMElement private

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:319`

Attempts to discover the element in the parent element. The default implementation looks for an element with an ID of `elementId` (or the view's guid if `elementId` is null). You can override this method to provide your own form of lookup. For example, if you want to discover your element using a CSS class name instead of an ID.

#### Parameters:

- `parentElement` DOMElement
  The parent's DOM element

#### Returns:

DOMElement: The discovered element

### `get`

(

- `keyName`

)
Object public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:96`

Retrieves the value of a property from the object. This method is usually similar to using `object[keyName]` or `object.keyName`, however it supports both computed properties and the unknownProperty handler. Because `get` unifies the syntax for accessing all these kinds of properties, it can make many refactorings easier, such as replacing a simple property with a computed property, or vice versa. ### Computed Properties Computed properties are methods defined with the `property` modifier declared at the end, such as: ```javascript fullName: Ember.computed('firstName', 'lastName', function() { return this.get('firstName') + ' ' + this.get('lastName'); }) ``` When you call `get` on a computed property, the function will be called and the return value will be returned instead of the function itself. ### Unknown Properties Likewise, if you try to call `get` on a property whose value is `undefined`, the `unknownProperty()` method will be called on the object. If this method returns any value other than `undefined`, it will be returned instead. This allows you to implement "virtual" properties that are not defined upfront.

#### Parameters:

- `keyName` String
  The property to retrieve

#### Returns:

Object: The property value or undefined.

### `getChildViews`

(

- `view`

)
private

Inherited from Ember.CoreView: `packages/ember-views/lib/system/utils.js:77`

#### Parameters:

- `view` Ember.View

### `getProperties`

(

- `list`

)
Object public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:139`

To get the values of multiple properties at once, call `getProperties` with a list of strings or an array: ```javascript record.getProperties('firstName', 'lastName', 'zipCode'); // { firstName: 'John', lastName: 'Doe', zipCode: '10011' } ``` is equivalent to: ```javascript record.getProperties(['firstName', 'lastName', 'zipCode']); // { firstName: 'John', lastName: 'Doe', zipCode: '10011' } ```

#### Parameters:

- `list` String... | Array
  of keys to get

#### Returns:

Object:

### `getRootViews`

(

- `owner`

)
private

Inherited from Ember.CoreView: `packages/ember-views/lib/system/utils.js:22`

#### Parameters:

- `owner` Object

### `getViewBoundingClientRect`

(

- `view`

)
private

Inherited from Ember.CoreView: `packages/ember-views/lib/system/utils.js:154`

`getViewBoundingClientRect` provides information about the position of the bounding border box edges of a view relative to the viewport. It is only intended to be used by development tools like the Ember Inpsector and may not work on older browsers.

#### Parameters:

- `view` Ember.View

### `getViewBounds`

(

- `view`

)
private

Inherited from Ember.CoreView: `packages/ember-views/lib/system/utils.js:114`

#### Parameters:

- `view` Ember.View

### `getViewClientRects`

(

- `view`

)
private

Inherited from Ember.CoreView: `packages/ember-views/lib/system/utils.js:138`

`getViewClientRects` provides information about the position of the border box edges of a view relative to the viewport. It is only intended to be used by development tools like the Ember Inspector and may not work on older browsers.

#### Parameters:

- `view` Ember.View

### `getViewElement`

(

- `view`

)
private

Inherited from Ember.CoreView: `packages/ember-views/lib/system/utils.js:58`

#### Parameters:

- `view` Ember.View

### `getViewId`

(

- `view`

)
private

Inherited from Ember.CoreView: `packages/ember-views/lib/system/utils.js:43`

#### Parameters:

- `view` Ember.View

### `getViewRange`

(

- `view`

)
private

Inherited from Ember.CoreView: `packages/ember-views/lib/system/utils.js:123`

#### Parameters:

- `view` Ember.View

### `getWithDefault`

(

- `keyName`
- `defaultValue`

)
Object public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:415`

Retrieves the value of a property, or a default value in the case that the property returns `undefined`. ```javascript person.getWithDefault('lastName', 'Doe'); ```

#### Parameters:

- `keyName` String
  The name of the property to retrieve
- `defaultValue` Object
  The value to return if the property value is undefined

#### Returns:

Object: The property value or the defaultValue.

### `handleEvent`

(

- `eventName`
- `evt`

)
private

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:468`

Handle events from `Ember.EventDispatcher`

#### Parameters:

- `eventName` String
- `evt` Event

### `has`

(

- `name`

)
Boolean public

Inherited from Ember.Evented: `packages/ember-runtime/lib/mixins/evented.js:142`

Checks to see if object has any subscriptions for named event.

#### Parameters:

- `name` String
  The name of the event

#### Returns:

Boolean: does the object have a subscription for event

### `hasObserverFor`

(

- `key`

)
Boolean private

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:400`

Returns `true` if the object currently has observers registered for a particular key. You can use this method to potentially defer performing an expensive action until someone begins observing a particular property on the object.

#### Parameters:

- `key` String
  Key to check

#### Returns:

Boolean:

### `incrementProperty`

(

- `keyName`
- `increment`

)
Number public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:433`

Set the value of a property to the current value plus some amount. ```javascript person.incrementProperty('age'); team.incrementProperty('score', 2); ```

#### Parameters:

- `keyName` String
  The name of the property to increment
- `increment` Number
  The amount to increment by. Defaults to 1

#### Returns:

Number: The new property value

### `init`

() private

Inherited from Ember.CoreObject but overwritten in `packages/ember-views/lib/mixins/view_support.js:427`

Setup a view, but do not finish waking it up. * configure `childViews` * register the view with the global views hash, which is used for event dispatch

### `matches`

(

- `el`
- `selector`

)
private

Inherited from Ember.CoreView: `packages/ember-views/lib/system/utils.js:170`

Determines if the element matches the specified selector.

#### Parameters:

- `el` DOMElement
- `selector` String

### `nearestOfType`

(

- `klass`

)
deprecated private

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:29`

Deprecated: use `yield` and contextual components for composition instead.

Return the nearest ancestor that is an instance of the provided class or mixin.

#### Parameters:

- `klass` Class,Mixin
  Subclass of Ember.View (or Ember.View itself), or an instance of Ember.Mixin.

#### Returns:

Ember.View

### `nearestWithProperty`

(

- `property`

)
deprecated private

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:52`

Deprecated: use `yield` and contextual components for composition instead.

Return the nearest ancestor that has a given property.

#### Parameters:

- `property` String
  A property name

#### Returns:

Ember.View

### `notifyPropertyChange`

(

- `keyName`

)
Ember.Observable public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:318`

Convenience method to call `propertyWillChange` and `propertyDidChange` in succession.

#### Parameters:

- `keyName` String
  The property key to be notified about.

#### Returns:

Ember.Observable:

### `off`

(

- `name`
- `target`
- `method`

)
public

Inherited from Ember.Evented: `packages/ember-runtime/lib/mixins/evented.js:127`

Cancels subscription for given name, target, and method.

#### Parameters:

- `name` String
  The name of the event
- `target` Object
  The target of the subscription
- `method` Function
  The function of the subscription

#### Returns:

this

### `on`

(

- `name`
- `[target]`
- `method`

)
public

Inherited from Ember.Evented: `packages/ember-runtime/lib/mixins/evented.js:52`

Subscribes to a named event with given function. ```javascript person.on('didLoad', function() { // fired once the person has loaded }); ``` An optional target can be passed in as the 2nd argument that will be set as the "this" for the callback. This is a good way to give your function access to the object triggering the event. When the target parameter is used the callback becomes the third argument.

#### Parameters:

- `name` String
  The name of the event
- `[target]` Object optional
  The "this" binding for the callback
- `method` Function
  The callback to execute

#### Returns:

this

### `one`

(

- `name`
- `[target]`
- `method`

)
public

Inherited from Ember.Evented: `packages/ember-runtime/lib/mixins/evented.js:78`

Subscribes a function to a named event and then cancels the subscription after the first time the event is triggered. It is good to use ``one`` when you only care about the first time an event has taken place. This function takes an optional 2nd argument that will become the "this" value for the callback. If this argument is passed then the 3rd argument becomes the function.

#### Parameters:

- `name` String
  The name of the event
- `[target]` Object optional
  The "this" binding for the callback
- `method` Function
  The callback to execute

#### Returns:

this

### `propertyDidChange`

(

- `keyName`

)
Ember.Observable private

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:294`

Notify the observer system that a property has just changed. Sometimes you need to change a value directly or indirectly without actually calling `get()` or `set()` on it. In this case, you can use this method and `propertyWillChange()` instead. Calling these two methods together will notify all observers that the property has potentially changed value. Note that you must always call `propertyWillChange` and `propertyDidChange` as a pair. If you do not, it may get the property change groups out of order and cause notifications to be delivered more often than you would like.

#### Parameters:

- `keyName` String
  The property key that has just changed.

#### Returns:

Ember.Observable:

### `propertyWillChange`

(

- `keyName`

)
Ember.Observable private

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:270`

Notify the observer system that a property is about to change. Sometimes you need to change a value directly or indirectly without actually calling `get()` or `set()` on it. In this case, you can use this method and `propertyDidChange()` instead. Calling these two methods together will notify all observers that the property has potentially changed value. Note that you must always call `propertyWillChange` and `propertyDidChange` as a pair. If you do not, it may get the property change groups out of order and cause notifications to be delivered more often than you would like.

#### Parameters:

- `keyName` String
  The property key that is about to change.

#### Returns:

Ember.Observable:

### `readDOMAttr`

(

- `name`

)
public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:604`

Normally, Ember's component model is "write-only". The component takes a bunch of attributes that it got passed in, and uses them to render its template. One nice thing about this model is that if you try to set a value to the same thing as last time, Ember (through HTMLBars) will avoid doing any work on the DOM. This is not just a performance optimization. If an attribute has not changed, it is important not to clobber the element's "hidden state". For example, if you set an input's `value` to the same value as before, it will clobber selection state and cursor position. In other words, setting an attribute is not **always** idempotent. This method provides a way to read an element's attribute and also update the last value Ember knows about at the same time. This makes setting an attribute idempotent. In particular, what this means is that if you get an `<input>` element's `value` attribute and then re-render the template with the same value, it will avoid clobbering the cursor and selection position. Since most attribute sets are idempotent in the browser, you typically can get away with reading attributes using jQuery, but the most reliable way to do so is through this method.

#### Parameters:

- `name` String
  the name of the attribute

#### Returns:

String

### `removeObserver`

(

- `key`
- `target`
- `method`

)
public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:385`

Remove an observer you have previously registered on this object. Pass the same key, target, and method you passed to `addObserver()` and your target will no longer receive notifications.

#### Parameters:

- `key` String
  The key to observer
- `target` Object
  The target object to invoke
- `method` String | Function
  The method to invoke.

### `renderToElement`

(

- `tagName`

)
HTMLBodyElement deprecated private

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:180`

Deprecated: Use appendTo instead.

Creates a new DOM element, renders the view into it, then returns the element. By default, the element created and rendered into will be a `BODY` element, since this is the default context that views are rendered into when being inserted directly into the DOM. ```js let element = view.renderToElement(); element.tagName; // => "BODY" ``` You can override the kind of element rendered into and returned by specifying an optional tag name as the first argument. ```js let element = view.renderToElement('table'); element.tagName; // => "TABLE" ``` This method is useful if you want to render the view into an element that is not in the document's body. Instead, a new `body` element, detached from the DOM is returned. FastBoot uses this to serialize the rendered view into a string for transmission over the network. ```js app.visit('/').then(function(instance) { let element; Ember.run(function() { element = renderToElement(instance); }); res.send(serialize(element)); }); ```

#### Parameters:

- `tagName` String
  The tag of the element to create and render into. Defaults to "body".

#### Returns:

HTMLBodyElement: element

### `reopen`

() public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:721`

Augments a constructor's prototype with additional properties and functions: ```javascript const MyObject = Ember.Object.extend({ name: 'an object' }); o = MyObject.create(); o.get('name'); // 'an object' MyObject.reopen({ say(msg){ console.log(msg); } }) o2 = MyObject.create(); o2.say("hello"); // logs "hello" o.say("goodbye"); // logs "goodbye" ``` To add functions and properties to the constructor itself, see `reopenClass`

### `reopenClass`

() public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:757`

Augments a constructor's own properties and functions: ```javascript const MyObject = Ember.Object.extend({ name: 'an object' }); MyObject.reopenClass({ canBuild: false }); MyObject.canBuild; // false o = MyObject.create(); ``` In other words, this creates static properties and functions for the class. These are only available on the class and not on any instance of that class. ```javascript const Person = Ember.Object.extend({ name: "", sayHello() { alert("Hello. My name is " + this.get('name')); } }); Person.reopenClass({ species: "Homo sapiens", createPerson(newPersonsName){ return Person.create({ name:newPersonsName }); } }); let tom = Person.create({ name: "Tom Dale" }); let yehuda = Person.createPerson("Yehuda Katz"); tom.sayHello(); // "Hello. My name is Tom Dale" yehuda.sayHello(); // "Hello. My name is Yehuda Katz" alert(Person.species); // "Homo sapiens" ``` Note that `species` and `createPerson` are *not* valid on the `tom` and `yehuda` variables. They are only valid on `Person`. To add functions and properties to instances of a constructor by extending the constructor's prototype see `reopen`

### `replaceIn`

(

- `target`

)
Ember.View private

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:242`

Replaces the content of the specified parent element with this view's element. If the view does not have an HTML representation yet, the element will be generated automatically. Note that this method just schedules the view to be appended; the DOM element will not be appended to the given element until all bindings have finished synchronizing

#### Parameters:

- `target` String | DOMElement | JQuery
  A selector, element, HTML string, or jQuery object

#### Returns:

Ember.View: received

### `rerender`

() public

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:70`

Renders the view again. This will work regardless of whether the view is already in the DOM or not. If the view is in the DOM, the rendering process will be deferred to give bindings a chance to synchronize. If children were added during the rendering process using `appendChild`, `rerender` will remove them, because they will be added again if needed by the next `render`. In general, if the display of your view changes, you should modify the DOM element directly instead of manually calling `rerender`, which can be slow.

### `send`

(

- `actionName`
- `context`

)
public

Inherited from Ember.ActionHandler: `packages/ember-runtime/lib/mixins/action_handler.js:148`

Triggers a named action on the `ActionHandler`. Any parameters supplied after the `actionName` string will be passed as arguments to the action target function. If the `ActionHandler` has its `target` property set, actions may bubble to the `target`. Bubbling happens when an `actionName` can not be found in the `ActionHandler`'s `actions` hash or if the action target function returns `true`. Example ```js App.WelcomeRoute = Ember.Route.extend({ actions: { playTheme() { this.send('playMusic', 'theme.mp3'); }, playMusic(track) { // ... } } }); ```

#### Parameters:

- `actionName` String
  The action to trigger
- `context`
  a context to send with the action

### `sendAction`

(

- `[action]`
- `[params]`

)
public

Inherited from Ember.ActionSupport: `packages/ember-views/lib/mixins/action_support.js:28`

Calls an action passed to a component. For example a component for playing or pausing music may translate click events into action notifications of "play" or "stop" depending on some internal state of the component: ```javascript // app/components/play-button.js export default Ember.Component.extend({ click() { if (this.get('isPlaying')) { this.sendAction('play'); } else { this.sendAction('stop'); } } }); ``` The actions "play" and "stop" must be passed to this `play-button` component: ```handlebars {{! app/templates/application.hbs }} {{play-button play=(action "musicStarted") stop=(action "musicStopped")}} ``` When the component receives a browser `click` event it translate this interaction into application-specific semantics ("play" or "stop") and calls the specified action. ```javascript // app/controller/application.js export default Ember.Controller.extend({ actions: { musicStarted() { // called when the play button is clicked // and the music started playing }, musicStopped() { // called when the play button is clicked // and the music stopped playing } } }); ``` If no action is passed to `sendAction` a default name of "action" is assumed. ```javascript // app/components/next-button.js export default Ember.Component.extend({ click() { this.sendAction(); } }); ``` ```handlebars {{! app/templates/application.hbs }} {{next-button action=(action "playNextSongInAlbum")}} ``` ```javascript // app/controllers/application.js App.ApplicationController = Ember.Controller.extend({ actions: { playNextSongInAlbum() { ... } } }); ```

#### Parameters:

- `[action]` String optional
  the action to call
- `[params]` optional
  arguments for the action

### `set`

(

- `keyName`
- `value`

)
Object public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:164`

Sets the provided key or path to the value. ```javascript record.set("key", value); ``` This method is generally very similar to calling `object["key"] = value` or `object.key = value`, except that it provides support for computed properties, the `setUnknownProperty()` method and property observers. ### Computed Properties If you try to set a value on a key that has a computed property handler defined (see the `get()` method for an example), then `set()` will call that method, passing both the value and key instead of simply changing the value itself. This is useful for those times when you need to implement a property that is composed of one or more member properties. ### Unknown Properties If you try to set a value on a key that is undefined in the target object, then the `setUnknownProperty()` handler will be called instead. This gives you an opportunity to implement complex "virtual" properties that are not predefined on the object. If `setUnknownProperty()` returns undefined, then `set()` will simply set the value on the object. ### Property Observers In addition to changing the property, `set()` will also register a property change with the object. Unless you have placed this call inside of a `beginPropertyChanges()` and `endPropertyChanges(),` any "local" observers (i.e. observer methods declared on the same object), will be called immediately. Any "remote" observers (i.e. observer methods declared on another object) will be placed in a queue and called at a later time in a coalesced manner.

#### Parameters:

- `keyName` String
  The property to set
- `value` Object
  The value to set or `null`.

#### Returns:

Object: The passed value

### `setProperties`

(

- `hash`

)
Object public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:213`

Sets a list of properties at once. These properties are set inside a single `beginPropertyChanges` and `endPropertyChanges` batch, so observers will be buffered. ```javascript record.setProperties({ firstName: 'Charles', lastName: 'Jolley' }); ```

#### Parameters:

- `hash` Object
  the hash of keys and values to set

#### Returns:

Object: The passed in hash

### `toggleProperty`

(

- `keyName`

)
Boolean public

Inherited from Ember.Observable: `packages/ember-runtime/lib/mixins/observable.js:473`

Set the value of a boolean property to the opposite of its current value. ```javascript starship.toggleProperty('warpDriveEngaged'); ```

#### Parameters:

- `keyName` String
  The name of the property to toggle

#### Returns:

Boolean: The new property value

### `toString`

() String public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:506`

Returns a string representation which attempts to provide more information than Javascript's `toString` typically does, in a generic way for all Ember objects. ```javascript const Person = Ember.Object.extend() person = Person.create() person.toString() //=> "" ``` If the object's class is not defined on an Ember namespace, it will indicate it is a subclass of the registered superclass: ```javascript const Student = Person.extend() let student = Student.create() student.toString() //=> "<(subclass of Person):ember1025>" ``` If the method `toStringExtension` is defined, its return value will be included in the output. ```javascript const Teacher = Person.extend({ toStringExtension() { return this.get('fullName'); } }); teacher = Teacher.create() teacher.toString(); //=> "" ```

#### Returns:

String: string representation

### `trigger`

(

- `name`

)
private

Inherited from Ember.Evented but overwritten in `packages/ember-views/lib/views/core_view.js:62`

Override the default event firing from `Ember.Evented` to also call methods with the given name.

#### Parameters:

- `name` String

### `triggerAction`

(

- `opts`

)
Boolean private

Inherited from Ember.TargetActionSupport: `packages/ember-runtime/lib/mixins/target_action_support.js:43`

Send an `action` with an `actionContext` to a `target`. The action, actionContext and target will be retrieved from properties of the object. For example: ```javascript App.SaveButtonView = Ember.View.extend(Ember.TargetActionSupport, { target: Ember.computed.alias('controller'), action: 'save', actionContext: Ember.computed.alias('context'), click() { this.triggerAction(); // Sends the `save` action, along with the current context // to the current controller } }); ``` The `target`, `action`, and `actionContext` can be provided as properties of an optional object argument to `triggerAction` as well. ```javascript App.SaveButtonView = Ember.View.extend(Ember.TargetActionSupport, { click() { this.triggerAction({ action: 'save', target: this.get('controller'), actionContext: this.get('context') }); // Sends the `save` action, along with the current context // to the current controller } }); ``` The `actionContext` defaults to the object you are mixing `TargetActionSupport` into. But `target` and `action` must be specified either as properties or with the argument to `triggerAction`, or a combination: ```javascript App.SaveButtonView = Ember.View.extend(Ember.TargetActionSupport, { target: Ember.computed.alias('controller'), click() { this.triggerAction({ action: 'save' }); // Sends the `save` action, along with a reference to `this`, // to the current controller } }); ```

#### Parameters:

- `opts` Object
  (optional, with the optional keys action, target and/or actionContext)

#### Returns:

Boolean: true if the action was sent successfully and did not return false

### `willDestroy`

() public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:479`

Override to implement teardown.

### `willRender`

() public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:745`

Available since 1.13.0

Called before a component has been rendered, both on initial render and in subsequent rerenders.

### `willUpdate`

() public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:777`

Available since 1.13.0

Called when the component is about to update and rerender itself. Called only during a rerender, not during an initial render.

## Properties

### `actions`

Object public

Inherited from Ember.ActionHandler: `packages/ember-runtime/lib/mixins/action_handler.js:27`

The collection of functions, keyed by name, available on this `ActionHandler` as action targets. These functions will be invoked when a matching `{{action}}` is triggered from within a template and the application's current route is this route. Actions can also be invoked from other parts of your application via `ActionHandler#send`. The `actions` hash will inherit action handlers from the `actions` hash defined on extended parent classes or mixins rather than just replace the entire hash, e.g.: ```js App.CanDisplayBanner = Ember.Mixin.create({ actions: { displayBanner(msg) { // ... } } }); App.WelcomeRoute = Ember.Route.extend(App.CanDisplayBanner, { actions: { playMusic() { // ... } } }); // `WelcomeRoute`, when active, will be able to respond // to both actions, since the actions hash is merged rather // then replaced when extending mixins / parent classes. this.send('displayBanner'); this.send('playMusic'); ``` Within a Controller, Route or Component's action handler, the value of the `this` context is the Controller, Route or Component object: ```js App.SongRoute = Ember.Route.extend({ actions: { myAction() { this.controllerFor("song"); this.transitionTo("other.route"); ... } } }); ``` It is also possible to call `this._super(...arguments)` from within an action handler if it overrides a handler defined on a parent class or mixin: Take for example the following routes: ```js App.DebugRoute = Ember.Mixin.create({ actions: { debugRouteInformation() { console.debug("trololo"); } } }); App.AnnoyingDebugRoute = Ember.Route.extend(App.DebugRoute, { actions: { debugRouteInformation() { // also call the debugRouteInformation of mixed in App.DebugRoute this._super(...arguments); // show additional annoyance window.alert(...); } } }); ``` ## Bubbling By default, an action will stop bubbling once a handler defined on the `actions` hash handles it. To continue bubbling the action, you must return `true` from the handler: ```js App.Router.map(function() { this.route("album", function() { this.route("song"); }); }); App.AlbumRoute = Ember.Route.extend({ actions: { startPlaying: function() { } } }); App.AlbumSongRoute = Ember.Route.extend({ actions: { startPlaying() { // ... if (actionShouldAlsoBeTriggeredOnParentRoute) { return true; } } } }); ```

Default: null

### `ariaRole`

String public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:640`

The WAI-ARIA role of the control represented by this view. For example, a button may have a role of type 'button', or a pane may have a role of type 'alertdialog'. This property is used by assistive software to help visually challenged users navigate rich web applications. The full list of valid WAI-ARIA roles is available at: [http://www.w3.org/TR/wai-aria/roles#roles_categorization](http://www.w3.org/TR/wai-aria/roles#roles_categorization)

Default: null

### `childViews`

Array private

Inherited from Ember.ClassNamesSupport: `packages/ember-views/lib/mixins/child_views_support.js:22`

Array of child views. You should never edit this array directly.

Default: []

### `classNameBindings`

Array public

Inherited from Ember.ClassNamesSupport: `packages/ember-views/lib/mixins/class_names_support.js:40`

A list of properties of the view to apply as class names. If the property is a string value, the value of that string will be applied as a class name. ```javascript // Applies the 'high' class to the view element Ember.Component.extend({ classNameBindings: ['priority'], priority: 'high' }); ``` If the value of the property is a Boolean, the name of that property is added as a dasherized class name. ```javascript // Applies the 'is-urgent' class to the view element Ember.Component.extend({ classNameBindings: ['isUrgent'], isUrgent: true }); ``` If you would prefer to use a custom value instead of the dasherized property name, you can pass a binding like this: ```javascript // Applies the 'urgent' class to the view element Ember.Component.extend({ classNameBindings: ['isUrgent:urgent'], isUrgent: true }); ``` This list of properties is inherited from the component's superclasses as well.

Default: []

### `classNames`

Array public

Inherited from Ember.ClassNamesSupport: `packages/ember-views/lib/mixins/class_names_support.js:28`

Standard CSS class names to apply to the view's outer element. This property automatically inherits any class names defined by the view's superclasses as well.

Default: ['ember-view']

### `concatenatedProperties`

Array public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:256`

Defines the properties that will be concatenated from the superclass (instead of overridden). By default, when you extend an Ember class a property defined in the subclass overrides a property with the same name that is defined in the superclass. However, there are some cases where it is preferable to build up a property's value by combining the superclass' property value with the subclass' value. An example of this in use within Ember is the `classNames` property of `Ember.View`. Here is some sample code showing the difference between a concatenated property and a normal one: ```javascript const Bar = Ember.Object.extend({ // Configure which properties to concatenate concatenatedProperties: ['concatenatedProperty'], someNonConcatenatedProperty: ['bar'], concatenatedProperty: ['bar'] }); const FooBar = Bar.extend({ someNonConcatenatedProperty: ['foo'], concatenatedProperty: ['foo'] }); let fooBar = FooBar.create(); fooBar.get('someNonConcatenatedProperty'); // ['foo'] fooBar.get('concatenatedProperty'); // ['bar', 'foo'] ``` This behavior extends to object creation as well. Continuing the above example: ```javascript let fooBar = FooBar.create({ someNonConcatenatedProperty: ['baz'], concatenatedProperty: ['baz'] }) fooBar.get('someNonConcatenatedProperty'); // ['baz'] fooBar.get('concatenatedProperty'); // ['bar', 'foo', 'baz'] ``` Adding a single property that is not an array will just add it in the array: ```javascript let fooBar = FooBar.create({ concatenatedProperty: 'baz' }) view.get('concatenatedProperty'); // ['bar', 'foo', 'baz'] ``` Using the `concatenatedProperties` property, we can tell Ember to mix the content of the properties. In `Ember.Component` the `classNames`, `classNameBindings` and `attributeBindings` properties are concatenated. This feature is available for you to use throughout the Ember object model, although typical app developers are likely to use it infrequently. Since it changes expectations about behavior of properties, you should properly document its usage in each individual concatenated property (to not mislead your users to think they can override the property in a subclass).

Default: null

### `element`

DOMElement public

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:95`

Returns the current DOM element for the view.

### `elementId`

String public

Inherited from Ember.ViewMixin but overwritten in `packages/ember-glimmer/lib/component.js:845`

The HTML `id` of the component's element in the DOM. You can provide this value yourself but it must be unique (just as in HTML): ```handlebars {{my-component elementId="a-really-cool-id"}} ``` If not manually set a default value will be provided by the framework. Once rendered an element's `elementId` is considered immutable and you should never change it. If you need to compute a dynamic value for the `elementId`, you should do this when the component or element is being instantiated: ```javascript export default Ember.Component.extend({ init() { this._super(...arguments); var index = this.get('index'); this.set('elementId', `component-id${index}`); } }); ```

### `isDestroyed`

Unknown public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:403`

Destroyed object property flag. if this property is `true` the observers and bindings were already removed by the effect of calling the `destroy()` method.

Default: false

### `isDestroying`

Unknown public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:428`

Destruction scheduled flag. The `destroy()` method has been called. The object stays intact until the end of the run loop at which point the `isDestroyed` flag is set.

Default: false

### `isVisible`

Boolean public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:874`

If `false`, the view will appear hidden in DOM.

Default: null

### `layout`

Function public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:809`

A component may contain a layout. A layout is a regular template but supersedes the `template` property during rendering. It is the responsibility of the layout template to retrieve the `template` property from the component (or alternatively, call `Handlebars.helpers.yield`, `{{yield}}`) to render it in the correct location. This is useful for a component that has a shared wrapper, but which delegates the rendering of the contents of the wrapper to the `template` property on a subclass.

### `layoutName`

String private

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:823`

The name of the layout to lookup if no layout is provided. By default `Ember.Component` will lookup a template with this name in `Ember.TEMPLATES` (a shared global object).

Default: null

### `mergedProperties`

Array public

Inherited from Ember.CoreObject: `packages/ember-runtime/lib/system/core_object.js:329`

Defines the properties that will be merged from the superclass (instead of overridden). By default, when you extend an Ember class a property defined in the subclass overrides a property with the same name that is defined in the superclass. However, there are some cases where it is preferable to build up a property's value by merging the superclass property value with the subclass property's value. An example of this in use within Ember is the `queryParams` property of routes. Here is some sample code showing the difference between a merged property and a normal one: ```javascript const Bar = Ember.Object.extend({ // Configure which properties are to be merged mergedProperties: ['mergedProperty'], someNonMergedProperty: { nonMerged: 'superclass value of nonMerged' }, mergedProperty: { page: {replace: false}, limit: {replace: true} } }); const FooBar = Bar.extend({ someNonMergedProperty: { completelyNonMerged: 'subclass value of nonMerged' }, mergedProperty: { limit: {replace: false} } }); let fooBar = FooBar.create(); fooBar.get('someNonMergedProperty'); // => { completelyNonMerged: 'subclass value of nonMerged' } // // Note the entire object, including the nonMerged property of // the superclass object, has been replaced fooBar.get('mergedProperty'); // => { // page: {replace: false}, // limit: {replace: false} // } // // Note the page remains from the superclass, and the // `limit` property's value of `false` has been merged from // the subclass. ``` This behavior is not available during object `create` calls. It is only available at `extend` time. In `Ember.Route` the `queryParams` property is merged. This feature is available for you to use throughout the Ember object model, although typical app developers are likely to use it infrequently. Since it changes expectations about behavior of properties, you should properly document its usage in each individual merged property (to not mislead your users to think they can override the property in a subclass).

Default: null

### `parentView`

Ember.View private

Inherited from Ember.CoreView: `packages/ember-views/lib/views/core_view.js:44`

If the view is currently inserted into the DOM of a parent view, this property will point to the parent of the view.

Default: null

### `tagName`

String public

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:406`

Tag name for the view's outer element. The tag name is only used when an element is first created. If you change the `tagName` for an element, you must destroy and recreate the view element. By default, the render buffer will use a `<div>` tag for views.

Default: null

## Events

### `didInsertElement`

public

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:344`

Called when the element of the view has been inserted into the DOM. Override this function to do any set up that requires an element in the document body. When a view has children, didInsertElement will be called on the child view(s) first and on itself afterwards.

### `didReceiveAttrs`

public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:719`

Available since 1.13.0

Called when the attributes passed into the component have been updated. Called both during the initial render of a container and during a rerender. Can be used in place of an observer; code placed here will be executed every time any attribute updates.

### `didRender`

public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:737`

Available since 1.13.0

Called after a component has been rendered, both on initial render and in subsequent rerenders.

### `didUpdate`

public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:801`

Available since 1.13.0

Called when the component has updated and rerendered itself. Called only during a rerender, not during an initial render.

### `didUpdateAttrs`

public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:769`

Available since 1.13.0

Called when the attributes passed into the component have been changed. Called only during a rerender, not during an initial render.

### `parentViewDidChange`

private

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:394`

Called when the parentView property has changed.

### `willClearRender`

public

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:357`

Called when the view is about to rerender, but before anything has been torn down. This is a good opportunity to tear down any manual observers you have installed based on the DOM state

### `willDestroyElement`

public

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:381`

Called when the element of the view is going to be destroyed. Override this function to do any teardown that requires an element, like removing event listeners. Please note: any property changes made during this event will have no effect on object observers.

### `willInsertElement`

public

Inherited from Ember.ViewMixin: `packages/ember-views/lib/mixins/view_support.js:336`

Called when a view is going to insert an element into the DOM.

### `willRender`

public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:753`

Available since 1.13.0

Called before a component has been rendered, both on initial render and in subsequent rerenders.

### `willUpdate`

public

Inherited from Ember.Component: `packages/ember-glimmer/lib/component.js:785`

Available since 1.13.0

Called when the component is about to update and rerender itself. Called only during a rerender, not during an initial render.